#define TSIZE 392
#define NTEMPLATES 3
#define NTRIES 3


#memmap xmem
// Usamos el hardware de lectura de la touch screen basado en MCP3204
#define TSCONTROLLER	2
/* Esto incluye la biblioteca de funciones de Cika que soporta el display
de 320x240 de Powertip */
#use "Cika320240FRST.lib"

#define DINBUFSIZE 1023
#define DOUTBUFSIZE 15

fontInfo fi8x10,fi10x12,fi6x8;

char buffer[800],buffer2[100];
int result,data,run;
long bitmap,templates;
unsigned  long userX;		// starting memory location where the user
									//	buttons will be stored.

cofunc void aimgene(int c)
{
int n;
   serDputc(c);
   wfd n=cof_serDread(buffer,sizeof(buffer),300);

   buffer[14]-=0x30;
   if(buffer[14]>=10)
       buffer[14]-=7;
   buffer[15]-=0x30;
   if(buffer[15]>=10)
       buffer[15]-=7;
   buffer[30]-=0x30;
   if(buffer[30]>=10)
       buffer[30]-=7;
   buffer[31]-=0x30;
   if(buffer[31]>=10)
       buffer[31]-=7;
   result=(buffer[14]<<4) | buffer[15];
   data=(buffer[30]<<4) | buffer[31];
//   buffer[n]=0;
//   printf("\nResult= %d, Data= %d\n%s",result,data,buffer);
}

cofunc void dedito()
{
   do {
      waitfor(BitRdPortI(PBDR,3));
      glPrintf(0,230,&fi8x10,"Listo para capturar tu dedito  ");
      waitfor(!BitRdPortI(PBDR,3));
      glPrintf(0,230,&fi8x10,"Capturando...                  ");
      wfd aimgene('C');
      if(result){
         glPrintf(0,230,&fi8x10,"PERO DEJALO PUESTO, APURADO !!!");
         waitfor(DelayMs(3000));
		}
   } while(result);
}

nodebug cofunc void getimage()
{
int i,j;

	serDputc('B');
   run=100;
	for(i=0,j=0;i<38;i++,j+=100){
		wfd cof_serDread(buffer,800,300);
#asm
  		   ld de,buffer
      	ld hl,buffer2
         ld b,100
l2:      ld (hl),0
      	ld c,0x80
l1:      ld a,(de)
	      cp 0x80
			jr c,noset
			ld a,c
	      or (hl)
         ld (hl),a
noset:   inc de
   	   srl c
      	xor a
	      or c
   	   jr nz,l1
      	inc hl
         djnz l2
#endasm
      root2xmem(bitmap+j,buffer2,100);
   }
}

cofunc void gettemplate(int i)
{
	serDputc('T');
	wfd cof_serDread(buffer,TSIZE,300);
   root2xmem(templates+TSIZE*i,buffer,TSIZE);
}

cofunc void puttemplate(int i)
{
	serDputc('M');
   xmem2root(buffer,templates+TSIZE*i,TSIZE);
   waitfor(DelayMs(1000));
   run=100;											// avoid "salir" while downloading
	wfd cof_serDwrite(buffer,TSIZE);
}


cofunc void fp_verify1()
{
      glPrintf(0,215,&fi8x10,"Primero capturamos el dedo");
      wfd dedito();
		waitfor(DelayMs(1000));
      glPrintf(0,230,&fi8x10,"OK, enrolling... (10 segundos)");
   	wfd aimgene('R');
      glPrintf(0,215,&fi8x10,"Listo, ahora verificamos  ");
      glPrintf(0,30,&fi8x10,"Resultado verificacion:");
	   while(run){
			wfd dedito();
	      glPrintf(200,30,&fi8x10,"     ");
			waitfor(DelayMs(1000));
	      glPrintf(0,230,&fi8x10,"Capturado, verificando...   ");
	   	wfd aimgene('V');
		   if(result) {
		      glPrintf(0,230,&fi8x10,"No me va ni a palos         ");
		      glPrintf(200,30,&fi8x10,"falla");
         }
         else {
		      glPrintf(0,230,&fi8x10,"Parece ser el mismo         ");
		      glPrintf(200,30,&fi8x10,"OK");
         }
	  	   waitfor(DelayMs(1000));
		}
}



cofunc void fp_identify()
{
int i,entradas[4];

   for(i=0;i<4;i++)
   	entradas[i]=0;
   if (run==5){
		for(i=1;i<5;i++){
	   	wfd aimgene(0x30+i);
   		if(i>1)
	   	   waitfor(DelayMs(1000));
	      glPrintf(0,215,&fi8x10,"Dedo #%d",i);
   	  	wfd dedito();
      	glPrintf(0,230,&fi8x10,"OK, enrolling... (10 segundos)");
	      waitfor(DelayMs(1000));
  		   wfd aimgene('E');
      }
   }
   glPrintf(0,215,&fi8x10,"Listo para identificar");
   while(run){
      wfd dedito();
      waitfor(DelayMs(1000));
      glPrintf(0,230,&fi8x10,"Capturado, verificando...     ");
      wfd aimgene('I');
      if(result)
         glPrintf(0,230,&fi8x10,"No me va ni a palos             ");
      else {
         glPrintf(0,230,&fi8x10,"Parece ser el dedo #%d          ",data);
         if(data<5)
        		entradas[data-1]++;
      }
      for(i=0;i<4;i++)
			glPrintf(0,30+15*i,&fi8x10,"Dedo #%d: %d",i+1,entradas[i]);
  	   waitfor(DelayMs(1000));
   }
}


cofunc void fp_verifyNcap()
{
int i;

		for(i=0;i<NTEMPLATES;i++){
			if(i)
	         waitfor(DelayMs(1000));
		   glPrintf(0,215,&fi8x10,"Dedo #%d",i+1);
        	wfd dedito();
		   glPrintf(0,230,&fi8x10,"OK, enrolling... (10 segundos)");
         waitfor(DelayMs(1000));
     	   wfd aimgene('R');
  	      glPrintf(0,230,&fi8x10,"OK, uploading...              ");
         waitfor(DelayMs(1000));
     	   wfd gettemplate(i);
         serDrdFlush();		// remove extra garbage from serial port
      }
}

cofunc void fp_verifyN(int i)
{
int j;

	   glPrintf(0,215,&fi8x10,"Listo para verificar dedo #%d",i+1);
      glPrintf(0,230,&fi8x10,"Downloading template #%d...",i+1);
		btnClear(userX,7);
      wfd puttemplate(i);
		btnDisplay(userX,7);
      if(run){
      	run=1;				// was put at 100 by puttemplate and was not reset
			waitfor(DelayMs(1000));
   	   serDrdFlush();		// remove extra garbage from serial port
      	j=0;
	      glPrintf(0,30,&fi8x10,"Resultado verificacion:");
			do {
   	     	wfd dedito();
				waitfor(DelayMs(1000));
         	glPrintf(0,230,&fi8x10,"Capturado, verificando...");
		      glPrintf(200,30,&fi8x10,"     ");
	  			wfd aimgene('V');
   		   if(result) {
  					glPrintf(0,230,&fi8x10,"No me va ni a palos      ");
			      glPrintf(200,30,&fi8x10,"falla");
         	   j++;
			  	   waitfor(DelayMs(1000));
   	      }
      	} while(result && (j<NTRIES));
	      if(result)
   	     	glPrintf(0,230,&fi8x10,"Cambiemos de dedo...    ");
      	else {
        		glPrintf(0,230,&fi8x10,"Parece ser el mismo     ");
		      glPrintf(200,30,&fi8x10,"OK");
         }
	  	   waitfor(DelayMs(1000));
      }
}


cofunc void fp_image()
{

	glPlotPolygon(4,167,0,319,0,319,200,167,200); 		// draw fingerprint screen
	do {
     	run=1;				// was put at 100 by getimage and was not reset
  	  	wfd dedito();
      glPrintf(0,230,&fi8x10,"OK, cargando imagen");
      waitfor(DelayMs(1000));
		btnClear(userX,7);
      wfd getimage();
		btnDisplay(userX,7);
		glXPutBitmap(168,0,152,200,bitmap);
      serDrdFlush();		// remove extra garbage from serial port
   } while(run);

}

CoData demo;

main()
{
int btn,btns;

	brdInit();
	glInit();
   bitmap=xalloc(3800L);
	templates=xalloc(NTEMPLATES*TSIZE);

	glXFontInit ( &fi8x10,8,10,0x20,0x7E,Font8x10 );
	glXFontInit ( &fi10x12,10,12,0x20,0x7E,Terminal9 );
	glXFontInit ( &fi6x8,6,8,0x20,0x7E,Font6x8 );

	userX = btnInit( 11 );
	btnCreateText(userX,1,10,100,70,40,1,1,&fi8x10,"Verify 1");
	btnCreateText(userX,2,90,100,70,40,1,1,&fi8x10,"Identify");
	btnCreateText(userX,3,170,100,70,40,1,1,&fi8x10,"Verify N");
	btnCreateText(userX,4,250,100,60,40,1,1,&fi8x10,"Imagen");
	btnCreateText(userX,5,10,100,140,40,1,2,&fi8x10,"Cargar templates");
	btnCreateText(userX,6,170,100,140,40,1,2,&fi8x10,"Usar templates");
	btnCreateText(userX,7,250,204,60,30,1,3,&fi8x10,"Salir");
	btnCreateText(userX,8,20,100,80,30,1,4,&fi8x10,"Dedo 1");
	btnCreateText(userX,9,120,100,80,30,1,4,&fi8x10,"Dedo 2");
	btnCreateText(userX,10,220,100,80,30,1,4,&fi8x10,"Dedo 3");
	btnAttributes(userX,1,0,0,0,0);
	btnAttributes(userX,2,0,0,0,0);
	btnAttributes(userX,3,0,0,0,0);
	btnAttributes(userX,4,0,0,0,0);
	btnAttributes(userX,5,0,0,0,0);
	btnAttributes(userX,6,0,0,0,0);
	btnAttributes(userX,7,0,0,0,0);
	btnAttributes(userX,8,0,0,0,0);
	btnAttributes(userX,9,0,0,0,0);
	btnAttributes(userX,10,0,0,0,0);
	serDopen(115200);
   btn=0;
   run=0;

	while(1){
		costate {	// botones
			waitfor ( (	btns = btnGet(userX) ) >= 0 );
         btn=btns;
			if (btn==7){
            btn=0;
				if(run!=100){
               CoReset(&demo);
            	CoBegin(&demo);
            }
         	run=0;
         }
		}
		costate demo always_on {
			glBlankScreen();
			waitfor(DelayMs(1000));
	      serDrdFlush();		// remove extra garbage from serial port
      	while (!btnDisplayLevel(userX,1)); // Will display all buttons of Level 1
			waitfor ((run=btn)>0);
			while (!btnClearLevel(userX,1)); // remove buttons of Level 1
			glBlankScreen();
  	   	while (!btnDisplayLevel(userX,3)); // Will display all buttons of Level 3
			if(run==1){
  					glPrintf(0,0,&fi10x12,"Verificacion 1:1");
					wfd fp_verify1();
         }
         else {
         	if(run==4) {
					wfd fp_image();
            }
	         else {
		      	while (!btnDisplayLevel(userX,2)); // Will display all buttons of Level 2
               btn=0;
					waitfor (btn>0);
					while (!btnClearLevel(userX,2)); // remove buttons of Level 2
					glBlankScreen();
		      	while (!btnDisplayLevel(userX,3)); // Will display all buttons of Level 3
               if(run==2) {
	  					glPrintf(0,0,&fi10x12,"Identificacion 1:N (max 8)");
                  run=btn;
						wfd fp_identify();
               }
               else {
	  					glPrintf(0,0,&fi10x12,"Verificacion 1:1 (N)");
	               if(btn==5) {
							wfd fp_verifyNcap();				// capture fingerprints
				      	while (!btnClearLevel(userX,3)); // Will remove all buttons of Level 3
   						glBlankScreen();
		  					glPrintf(0,0,&fi10x12,"Verificacion 1:1 (N)");
                  }
						while(run){
				      	while (!btnDisplayLevel(userX,3)); // Will display all buttons of Level 3
					      glPrintf(10,30,&fi10x12,"Con que dedo debo comparar ?");
				      	while (!btnDisplayLevel(userX,4)); // Will display all buttons of Level 4
		               btn=0;
							waitfor (btn>0);
							while (!btnClearLevel(userX,4)); // remove buttons of Level 4
   						glBlankScreen();
		  					glPrintf(0,0,&fi10x12,"Verificacion 1:1 (N)");
			   	   	while (!btnDisplayLevel(userX,3)); // Will display all buttons of Level 3
							wfd fp_verifyN(btn-8);
                  }
               }
            }
			}
	   }
   }
}

int buzzer()
{
}